/* 
  eaters - by The Last Viking (C) 31. May 1997 Ekran Design.
  using ncurses.

  compile with: gcc -O -lncurses -lm eaters.c -oeaters
*/

#include <ncurses.h>
#include <stdlib.h>
#include <math.h>

#define false 1
#define true 0

int xite,gover,padx,pady,fsync;
int hiscore,sc;
int x,y,xm,ym;
int levl;

char pman;
char *board[100];
char shadowboard[20][60];
char eaters[5][6]; /* 4 eaters, with y=0, x=1, ch=3, my=4 mx=5 */
char ch;
struct _win_st wp;

int rnd(int i) {return (1+(int)(((float)i*rand())/(RAND_MAX-1)+1));}

void intro(void) {

 int xintr;
 int x,y,x2,y2,xo,yo,cnt;
 double dcnt,xd,yd;

 xintr=false;
 xo=0; yo=0;
 dcnt=0; cnt=0;
  do {
    if (cnt==1250) {cnt=0;dcnt=0;}
    mvprintw(8,35,"             ");
    mvprintw(10,20,"Written by The Last Viking 31. May 1997");
    mvprintw(12,19,"As usual, you're controlling wormie around");
    mvprintw(13,20,"the food table with the keys a,w,d and x");
    mvprintw(14,26,"use e to exit and s to start");
    mvprintw(16,32,"Last score: %d",sc);
    if (hiscore<sc) hiscore=sc;
    mvprintw(17,31,"Highest score: %d",hiscore);
    dcnt=dcnt+0.005; 
    xd=(cos(dcnt)*30);
    yd=(sin(dcnt)*12);
    x=35+(int)xd; y=12+(int)yd;
    x2=35-(int)xd; y2=12-(int)yd;
    if ((x2!=xo) || (y2!=yo)) mvprintw(yo,xo-1,"              ");
    mvprintw(y,x,"EATERS"); 
    xo=x2;yo=y2; 
    ch='a';
    ch=(char)getch();
    if (ch=='s') {xintr=true; xite=false; gover=false;}
    if (ch=='e') {xintr=true; xite=true; gover=false;}
    timeout(0);
  } while (xintr==false);
}

void keys(void) { 
  int padxb,padyb;
  padxb=padx; padyb=padyb; 
  ch=(char)getch();
  if (ch=='d') {padx=1; pady=0;}
  if (ch=='a') {padx=-1; pady=0;}
  if (ch=='w') {padx=0; pady=-1;}
  if (ch=='x') {padx=0; pady=1;}
  if (ch=='q') gover=true; /* get back to intro screen */
  if (ch=='e') xite=true;
}

void munchie_handler(void) {
 int oldmanx,oldmany;
 oldmanx=xm; oldmany=ym;
 keys();
 if ((padx!=0) && 
    ((shadowboard[ym][xm+padx]=='.') || (shadowboard[ym][xm+padx]==' '))) {
       xm=xm+padx;
       if ((shadowboard[ym][xm])=='.') {
          sc=sc+5+(rnd(9));
          mvprintw(ym,xm,"%c",shadowboard[ym][xm]=' '); 
       }   
 }
 if ((pady!=0) && 
    ((shadowboard[ym+pady][xm]=='.') || (shadowboard[ym+pady][xm]==' '))) {
      ym=ym+pady;
       if ((shadowboard[ym][xm])=='.') {
          sc=sc+5+(rnd(9));
          mvprintw(ym,xm,"%c",shadowboard[ym][xm]=' '); 
      }   
 }
 switch (pman) {
   case 'V':pman='|'; break;
   case '^':pman='|'; break;
   case '<':pman='-'; break;
   case '>':pman='-'; break;
   case '-':if (padx==1) pman='<'; 
            else 
              if (padx==-1) pman='>'; 
                else
                  if (padx==0) pman='|';
            break; 
   case '|':if (pady==1) pman='^';
            else 
             if (pady==-1) pman='V';
               else 
                 if (pady==0) pman='-'; 
            break; 
 }
 if ((oldmanx!=xm) || (oldmany!=ym)) 
    mvprintw(oldmany+7,oldmanx+30,"%c",shadowboard[oldmany][oldmanx]);
 for (x=0; x<4; x++) 
   if ((eaters[x][0]==ym) && (eaters[x][1]==xm)) {gover=true; xite=false;}
 mvprintw(ym+7,xm+30,"%c",pman);
}

void eaters_handler(void) {
 int ecnt;
 int yeb,xeb;
 int yemb,xemb;

 for (ecnt=0; ecnt<4; ecnt++) { /* delete */
   yeb=eaters[ecnt][0]; xeb=eaters[ecnt][1];
   mvprintw(7+yeb,30+xeb,"%c",shadowboard[yeb][xeb]);
   switch (eaters[ecnt][3]) {
      case 'm':eaters[ecnt][3]='M'; break;
      case 'M':eaters[ecnt][3]='m'; break;
   };
 }

 for (ecnt=0; ecnt<4; ecnt++) {
   yeb=eaters[ecnt][0]; xeb=eaters[ecnt][1];
   yemb=eaters[ecnt][4]; xemb=eaters[ecnt][5];
   
   if ((yemb!=0) && 
      ((shadowboard[yeb+yemb][xeb]==' ') || (shadowboard[yeb+yemb][xeb]=='.'))) 
      eaters[ecnt][0]=eaters[ecnt][0]+eaters[ecnt][4];
   else /* new direction */
     if (yemb!=0)
      if (rnd(100)>50) {
         if (rnd(100)>50) eaters[ecnt][4]=1; else eaters[ecnt][4]=-1; 
         eaters[ecnt][5]=0;
      } else {
         if (rnd(100)>50) eaters[ecnt][5]=1; else eaters[ecnt][5]=-1; 
         eaters[ecnt][4]=0;
      }

   if ((xemb!=0) && 
      ((shadowboard[yeb][xeb+xemb]==' ') || (shadowboard[yeb][xeb+xemb]=='.'))) 
      eaters[ecnt][1]=eaters[ecnt][1]+eaters[ecnt][5];
   else /* new direction */
    if (xemb!=0) 
     if (rnd(100)>50) {
         if (rnd(100)>50) eaters[ecnt][4]=-1; else eaters[ecnt][4]=1; 
         eaters[ecnt][5]=0;
      } else {
         if (rnd(100)>50) eaters[ecnt][5]=-1; else eaters[ecnt][5]=1; 
         eaters[ecnt][4]=0;
      }
 }   

 for (ecnt=0; ecnt<4; ecnt++) { /* move and check if they hit munchie */
   mvprintw(7+eaters[ecnt][0],30+eaters[ecnt][1],"%c",eaters[ecnt][3]);
   if ((eaters[ecnt][0]==ym) && (eaters[ecnt][1]==xm)) {xite=false;gover=true;}
 }
}

void initnl(int st,int ee) {
  for (y=st; y<=ee; y++)
    for (x=0; x<=28; x++) {
     shadowboard[y-st][x]=*(board[y]+x); 
      mvprintw(7+(y-st),30+x,"%c",shadowboard[y-st][x]);
  }
  for (x=0; x<4; x++) {
   eaters[x][0]=5; eaters[x][1]=9+(x*2); eaters[x][3]='M'; 
    eaters[x][4]=1; eaters[x][5]=0;
  }
  eaters[2][1]++; eaters[3][1]++; eaters[3][1]++;
  eaters[2][3]='m'; eaters[0][3]='m';
  xm=3;ym=10;
  ch='.'; padx=1; pady=0; pman='<';
  xite=false; gover=false;
}

void chckall(void) {
int chk;
 chk=false;
 for (y=0; y<=11; y++)
   for (x=0; x<=28; x++)
     if (shadowboard[y][x]=='.') chk=true;
 if (chk==true) return;
 levl++; if (levl==5) levl=0;
 if (levl==0) initnl(0,11);
 if (levl==1) initnl(20,31);
 if (levl==2) initnl(40,51);
 if (levl==3) initnl(60,71);
 if (levl==4) initnl(80,91);
}

void main(void) {
 wp=*initscr(); /* initialize curses */
 cbreak();
 noecho();
 nonl();
 intrflush(stdscr, FALSE);
 keypad(stdscr, TRUE);
 nodelay(stdscr,TRUE);
 curs_set(0);
 hiscore=0;
 board[0]= "/===========================\\Q";
 board[1]= "|..........X.....X......X...|Q";
 board[2]= "|.X.XXXXXX.X.XXX.X.XXXX.X.X.|Q";
 board[3]= "|.X..............X........X.|Q";
 board[4]= "|.X.XXXXXXXXXX.XXX.XXXXXXXXX|Q";
 board[5]= "|.X.X................X......|Q";
 board[6]= "|.X...XXXXXX.XXXXXXX.X.XXXX.|Q";
 board[7]= "|.XXXXX......X.......X.X..X.|Q";
 board[8]= "|.......XXXX.X.XXXXX......X.|Q";
 board[9]= "|.XXXXXXX....X.......XXXXXX.|Q";
 board[10]="|.........XXXXXXXXXX........|Q";
 board[11]="\\===========================/Q";
  
 board[20]= "/===========================\\Q";
 board[21]= "|.X........X................|Q";
 board[22]= "|.X.XXXXXX.X.XXX.X.XXXX.XXX.|Q";
 board[23]= "|.X..............X..........|Q";
 board[24]= "|.X.XXXXXXXXXX.XXXXX.XXXXXXX|Q";
 board[25]= "|.X.X................X......|Q";
 board[26]= "|...X.XXXXXXXXXXXXXX.X.XXXX.|Q";
 board[27]= "|.XXX.XX.............X.XX.X.|Q";
 board[28]= "|...X....XXX.X.XXXXX.X....X.|Q";
 board[29]= "|.XXXXXXXX...X.......XXXXXX.|Q";
 board[30]= "|..........X...XXXXX........|Q";
 board[31]="\\===========================/Q";
  
 board[40]= "/===========================\\Q";
 board[41]= "|..................X........|Q";
 board[42]= "|.X.XXXXXXXX.XXX.X.X.XX.XXX.|Q";
 board[43]= "|.X..............X..........|Q";
 board[44]= "|.X.X.XXXXXXXX.XXXXX.XXXXXX.|Q";
 board[45]= "|.X.X.X................XX...|Q";
 board[46]= "|...X.XX.XXXXXXXXXXX.X....X.|Q";
 board[47]= "|XX.X.X..............XXXX.X.|Q";
 board[48]= "|.X......XXX.X.XXXXX.X....X.|Q";
 board[49]= "|.XXX.XXXX...X.......X.XXXX.|Q";
 board[50]= "|..............XXXXX........|Q";
 board[51]="\\===========================/Q";
 
 board[60]= "/===========================\\Q";
 board[61]= "|...........................|Q";
 board[62]= "|.X.XXXXXXXXXXXXXXXXXXXXXXX.|Q";
 board[63]= "|.X.......................X.|Q";
 board[64]= "|.X.X.XXXXXXXX.XXXXX.XXXX.X.|Q";
 board[65]= "|.X.X.X................XX.X.|Q";
 board[66]= "|...X.XX.XXXXXXXXXXX.X....X.|Q";
 board[67]= "|XX.X.X............X.XXXX.X.|Q";
 board[68]= "|.X............X..........X.|Q";
 board[69]= "|.XXXXXXXXXXXXXXXXXX.XXXXXX.|Q";
 board[70]= "|...........................|Q";
 board[71]="\\===========================/Q";
  
 board[80]= "/===========================\\Q";
 board[81]= "|........X...........XXX....|Q";
 board[82]= "|X..........................|Q";
 board[83]= "|..............X...X...X....|Q";
 board[84]= "|....X......................|Q";
 board[85]= "|..........X...............X|Q";
 board[86]= "|.....X................X....|Q";
 board[87]= "|X.......X..........X.......|Q";
 board[88]= "|.............X.............|Q";
 board[89]= "|...X......................X|Q";
 board[90]= "|..............X............|Q";
 board[91]="\\===========================/Q";

 do {
   clear();
   intro();
   clear();
   sc=0; 
   initnl(0,11);
   levl=0;
   do {
     fsync=false;
     keys();
     munchie_handler();
     eaters_handler();
     chckall();
     wrefresh(&wp);
     timeout(150);
     mvprintw(24,3," SCORE: %d ",sc); 
   } while ((gover==false) && (xite==false));
 } while (xite==false);
 clear();
 printw("bye.");
 wrefresh(&wp);
 endwin();
}

